/* Application.c generated by valac 0.56.18, the Vala compiler
 * generated from Application.vala, do not modify */

/*
 * Copyright 2018-2024 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authors: Corentin Noël <corentin@elementary.io>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <locale.h>
#include <glib/gi18n-lib.h>

#define CONSTANTS_GETTEXT_PACKAGE "io.elementary.greeter"
#define CONSTANTS_LOCALE_DIR "/usr/share/locale"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GREETER_TYPE_APPLICATION (greeter_application_get_type ())
#define GREETER_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GREETER_TYPE_APPLICATION, GreeterApplication))
#define GREETER_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GREETER_TYPE_APPLICATION, GreeterApplicationClass))
#define GREETER_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GREETER_TYPE_APPLICATION))
#define GREETER_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GREETER_TYPE_APPLICATION))
#define GREETER_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GREETER_TYPE_APPLICATION, GreeterApplicationClass))

typedef struct _GreeterApplication GreeterApplication;
typedef struct _GreeterApplicationClass GreeterApplicationClass;
typedef struct _GreeterApplicationPrivate GreeterApplicationPrivate;
enum  {
	GREETER_APPLICATION_0_PROPERTY,
	GREETER_APPLICATION_NUM_PROPERTIES
};
static GParamSpec* greeter_application_properties[GREETER_APPLICATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GREETER_TYPE_MAIN_WINDOW (greeter_main_window_get_type ())
#define GREETER_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GREETER_TYPE_MAIN_WINDOW, GreeterMainWindow))
#define GREETER_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GREETER_TYPE_MAIN_WINDOW, GreeterMainWindowClass))
#define GREETER_IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GREETER_TYPE_MAIN_WINDOW))
#define GREETER_IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GREETER_TYPE_MAIN_WINDOW))
#define GREETER_MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GREETER_TYPE_MAIN_WINDOW, GreeterMainWindowClass))

typedef struct _GreeterMainWindow GreeterMainWindow;
typedef struct _GreeterMainWindowClass GreeterMainWindowClass;

struct _GreeterApplication {
	GtkApplication parent_instance;
	GreeterApplicationPrivate * priv;
};

struct _GreeterApplicationClass {
	GtkApplicationClass parent_class;
};

static gpointer greeter_application_parent_class = NULL;

VALA_EXTERN GType greeter_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GreeterApplication, g_object_unref)
VALA_EXTERN GreeterApplication* greeter_application_new (void);
VALA_EXTERN GreeterApplication* greeter_application_construct (GType object_type);
static void greeter_application_real_startup (GApplication* base);
static void greeter_application_real_activate (GApplication* base);
VALA_EXTERN GreeterMainWindow* greeter_main_window_new (void);
VALA_EXTERN GreeterMainWindow* greeter_main_window_construct (GType object_type);
VALA_EXTERN GType greeter_main_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GreeterMainWindow, g_object_unref)
static gint greeter_application_main (gchar** args,
                               gint args_length1);
static GObject * greeter_application_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static GType greeter_application_get_type_once (void);

GreeterApplication*
greeter_application_construct (GType object_type)
{
	GreeterApplication * self = NULL;
	self = (GreeterApplication*) g_object_new (object_type, "application-id", "io.elementary.greeter", "flags", G_APPLICATION_FLAGS_NONE, NULL);
	return self;
}

GreeterApplication*
greeter_application_new (void)
{
	return greeter_application_construct (GREETER_TYPE_APPLICATION);
}

static void
greeter_application_real_startup (GApplication* base)
{
	GreeterApplication * self;
	GtkCssProvider* css_provider = NULL;
	GtkCssProvider* _tmp0_;
	GdkScreen* _tmp1_;
	self = (GreeterApplication*) base;
	G_APPLICATION_CLASS (greeter_application_parent_class)->startup ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication));
	_tmp0_ = gtk_css_provider_new ();
	css_provider = _tmp0_;
	gtk_css_provider_load_from_resource (css_provider, "/io/elementary/greeter/Application.css");
	_tmp1_ = gdk_screen_get_default ();
	gtk_style_context_add_provider_for_screen (_tmp1_, (GtkStyleProvider*) css_provider, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	_g_object_unref0 (css_provider);
}

static void
greeter_application_real_activate (GApplication* base)
{
	GreeterApplication * self;
	GreeterMainWindow* _tmp0_;
	GreeterMainWindow* _tmp1_;
	GtkWindow* _tmp2_;
	GtkWindow* _tmp3_;
	self = (GreeterApplication*) base;
	_tmp0_ = greeter_main_window_new ();
	g_object_ref_sink (_tmp0_);
	_tmp1_ = _tmp0_;
	gtk_application_add_window ((GtkApplication*) self, (GtkWindow*) _tmp1_);
	_g_object_unref0 (_tmp1_);
	_tmp2_ = gtk_application_get_active_window ((GtkApplication*) self);
	_tmp3_ = _tmp2_;
	gtk_widget_show_all ((GtkWidget*) _tmp3_);
}

static gint
greeter_application_main (gchar** args,
                          gint args_length1)
{
	GreeterApplication* _tmp0_;
	GreeterApplication* _tmp1_;
	gint _tmp2_;
	gint result;
	_tmp0_ = greeter_application_new ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_application_run ((GApplication*) _tmp1_, (gint) args_length1, args);
	_g_object_unref0 (_tmp1_);
	result = _tmp2_;
	return result;
}

int
main (int argc,
      char ** argv)
{
	return greeter_application_main (argv, argc);
}

static GObject *
greeter_application_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GreeterApplication * self;
	parent_class = G_OBJECT_CLASS (greeter_application_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GREETER_TYPE_APPLICATION, GreeterApplication);
	setlocale (LC_ALL, "");
	bind_textdomain_codeset (CONSTANTS_GETTEXT_PACKAGE, "UTF-8");
	textdomain (CONSTANTS_GETTEXT_PACKAGE);
	bindtextdomain (CONSTANTS_GETTEXT_PACKAGE, CONSTANTS_LOCALE_DIR);
	return obj;
}

static void
greeter_application_class_init (GreeterApplicationClass * klass,
                                gpointer klass_data)
{
	greeter_application_parent_class = g_type_class_peek_parent (klass);
	((GApplicationClass *) klass)->startup = (void (*) (GApplication*)) greeter_application_real_startup;
	((GApplicationClass *) klass)->activate = (void (*) (GApplication*)) greeter_application_real_activate;
	G_OBJECT_CLASS (klass)->constructor = greeter_application_constructor;
}

static void
greeter_application_instance_init (GreeterApplication * self,
                                   gpointer klass)
{
}

static GType
greeter_application_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GreeterApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) greeter_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GreeterApplication), 0, (GInstanceInitFunc) greeter_application_instance_init, NULL };
	GType greeter_application_type_id;
	greeter_application_type_id = g_type_register_static (gtk_application_get_type (), "GreeterApplication", &g_define_type_info, 0);
	return greeter_application_type_id;
}

GType
greeter_application_get_type (void)
{
	static volatile gsize greeter_application_type_id__once = 0;
	if (g_once_init_enter (&greeter_application_type_id__once)) {
		GType greeter_application_type_id;
		greeter_application_type_id = greeter_application_get_type_once ();
		g_once_init_leave (&greeter_application_type_id__once, greeter_application_type_id);
	}
	return greeter_application_type_id__once;
}

